<?php

    // Interfaz PHP a la API de bsqueda de Google
    // Copyleft 2005, Reven Snchez
    // versin 1.0a - 17 Marzo 2005
    // Licencia Creative Commons by-sa-nc (http://creativecommons.org/licenses/by-nc-sa/2.1/es/)
    // Permitida su redistribucin/re-utilizacin/edicin siempre que se mantenga esta licencia
    // y que no sea redistribuido con fines comerciales.
    // Utiliza este script segn creas necesario. Modificalo a tu gusto!
    //
    // Sera un detalle un agradecimiento o link a www.reven.org
    // Tambin donaciones a travs de Pay Pal a reven@reven.org

    error_reporting(E_ALL & ~E_NOTICE);


    // Cronometraremos el script
    $timeparts = explode(' ',microtime());
    $starttime = $timeparts[1].substr($timeparts[0],1);


    // Parmetros de configuracin

    $clave = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
    // Tu clave para utilizar la API de Google. Si no tienes una visita https://www.google.com/accounts/NewAccount?continue=http://api.google.com/createkey&followup=http://api.google.com/createkey

    $site = "www.miweb.com";                          // El sitio que deseas buscar. Normalmente el tuyo
                                                      // Si no se especifica buscar la web entera

    $spelling = 0;                                    // Cambia a 1 para que la bsqueda devuelva sugerencias ortogrficas

    // FIN Parmetros de configuracin

    $estescript = $_SERVER['PHP_SELF'];
    $apiurl = "http://api.google.com/search/beta2";


    // Obtenemos la bsqueda
    $q = stripslashes ($HTTP_GET_VARS['q']);
    $start = 0 + (stripslashes ($HTTP_GET_VARS['start']));     // Sumo cero para cambiar su tipo a entero: "truco"

    include ("header.php");                           // Editar este archivo para ajustar a nuestro sitio


    if (!$q) {                                        // Si no est definido 'q' entonces hay que dar un formulario
        echo <<<EOT
      <h2>Bsqueda</h2><br /><br /><br />
      <form  style="display: inline;" method="get" action="$estescript">
        <p style="display: inline;">
          <input maxlength="255" name="q" size="40" />
          <input type="submit" value="Buscar!" />
        </p>
      </form>

EOT;

    }else{                                            // Haz la bsqueda


    include_once('nusoap.php');                       // el que hace la magia
    $fullquery = "$q site:$site";

    // Significado de los parmetros en http://www.google.com/apis/reference.html#searchrequest
    $APIparams = array("key"         => $clave,
                       "q"           => $fullquery,
                       "start"       => $start,
                       "maxResults"  => 10,           // mximo 10
                       "filter"      => false,
                       "restrict"    => "",
                       "safeSearch"  => true,
                       "lr"          => "",
                       "ie"          => "",
                       "oe"          => "");

    // Crear un nuevo cliente SOAP
    $Client = new soapclient($apiurl);

    // Obtener los resultados
    $QueryResult = $Client->call("doGoogleSearch", $APIparams, "urn:GoogleSearch");


    // Ver la documentacin de la API de Google -> http://www.google.com/apis/reference.html#search_results_format
    // Simplemente asignamos los resultados que queremos a variables. Se pueden asignar los que queramos
    // Yo he dejado fuera los que no me importan, como ortografa, filtros, etc.
    $total       = $QueryResult["estimatedTotalResultsCount"];
    $primero     = $QueryResult["startIndex"];
    $ultimo      = $QueryResult["endIndex"];
    $aproximado  = "aproximadamente ";                // Si los resultados son muchos tendremos un nmero aproximado
    $tiempogoogle= $QueryResult["searchTime"];
    if ($QueryResult["estimateIsExact"]){$aproximado  = "";} // Pero si el nmero es exacto, eliminamos este trmino



    if ($total > 0) {                                 // Si hay resultados...

        echo "<h2>Resultados</h2>\n";
        // Esto muestra cosas adicionales que google devuelve en la bsqueda, como p.ej. "La palabra "a" es muy comn..."
        // echo $QueryResult["searchComments"];
        // echo $QueryResult["searchTips"];
        echo "<h4>";

        damemaslinks();
        echo "$primero - $ultimo de $aproximado $total resultados</h4>\n";

        // Los resultados en s
        $QueryResult = $QueryResult["resultElements"]; // una matriz que contiene los resultados en s. Ver API.

        for ($i = 0; $i < count($QueryResult); $i++) {
            $element     = $QueryResult[$i];
            $snippet[$i] = $element["snippet"];
            $snippet[$i] = str_replace("<br>","",$snippet[$i]); // quitamos los <br> que incluye el resultado
                                                                // para que texto se ajuste a nuestro 'lay-out'
            $url[$i]     = $element["URL"];
            $title[$i]   = $element["title"];
            $tamao      = $element["cachedSize"];
            if ($title[$i] == "") {$title[$i] = str_replace("http://","",$url[$i]);}  // Si no hay ttulo, usa URL
            echo '<p><a href="' . $url[$i] . '">' . $title[$i] . '</a><br />'."\n";
            if ($snippet[$i] != "") {
                echo $snippet[$i].'<br />'."\n        ";
            }
            echo '<span>' . $url[$i] . " ($tamao)" . '</span>';
            echo "\n</p>\n";
        }
        echo '      <h4>';
        damemaslinks();
        echo "&nbsp;</h4>\n";

    }else{                                            // No hay resultados

        echo "<h2>No se encontraron resultados</h2>\n";
        echo "<p>Lo siento, no se han encontrado pginas que contengan el trmino \"$q\".</p>\n";
    }

    } //fin de bsqueda


    include ("footer.php");

    // El usuario ya tiene el resultado, ahora lo logeamos
    // Esto es experimental y no se incluye el script para ver los resultados.
    // Si decides activarlo, puedes cambiar el formato de lo logeado.
    // De lo contrario, quita este bloque completamente.
    /*
    $gestor = fopen("/var/www/searchlog.txt", "a");       // Edita esta ruta!!
    $linealog = strftime("%H.%M.%S-%d.%m.%Y")."#"."$start"."#"."$q"."\n";
    fwrite($gestor, $linealog);
    fclose($gestor);
    */
    // Fin del bloque log



    // Funciones

    // Links a los resultados sucesivos si hay ms de 10
    function damemaslinks(){
        global $estescript,$q,$total,$ultimo,$primero;
        if ($ultimo - $primero < 9) $total = $ultimo;
        if ($total > 10) {
            if ($primero < 40) {
                $x = 0;
            } else {
                $x = round (max (0, min ($primero - 40, $total - 96) / 10));
            }
            echo "<span style=\"float:right;\">\n";
            for ($i = $x; $i < $x + 10; $i++) {
                if ($i != round ($primero / 10)) {
                    echo ("<a href=\"$estescript".'?q=' . urlencode($q) . '&amp;start=' . ($i * 10) . '">');
                    echo ( ($i + 1) . "</a>&nbsp;&nbsp;\n");
                } else {
                    echo ($i + 1) . "&nbsp;&nbsp;\n";
                }
                if (max (10, ($i + 1) * 10) >= $total) break;
            }
            echo "</span>\n";
        }
    }

    // Final del script
    // En footer.php podemos incluir funciones de php para mostrar informacin de depuracin de la bsqueda.
    // Yo lo he hecho as porque me gusta que la salida HTML empiece en header.php y termine en footer (y no en
    // el propio script; en mi opinin es ms sencillo controlar que generamos HTML vlido).
    // Por ello la funcin que toma el tiempo final y da el tiempo de ejecucin del script est en footer.php.
    // De todas formas por si sirve de referencia, aqu est:
    /*
    $timeparts = explode(' ',microtime());
    $endtime = $timeparts[1].substr($timeparts[0],1);
    $tiempoempleado = bcsub($endtime,$starttime,6);
    */
?>
